#!/usr/bin/perl
##
## user adminster her own data value in the counter database via web.
## It is part of WWW Homepage Access Counter
## uses AnyDBM_File Perl module
##
## Muhammad A Muquit
## http://www.fccc.edu/users/muquit/
## a vacation hack (hmm.. a sick hack, i was sick)
### Aug-13-1999
##

# change the order of modules if you need
BEGIN
{
    @AnyDBM_File::ISA=qw(DB_File GDBM_File NDBM_File)
}
use strict;
use Fcntl;
use AnyDBM_File();
use CGI;

my $query=new CGI;


#------------globals starts-------------------
my $g_debug=0;

# create the following file in the same directory of the cgi program
# the format is
# userid|Unix_crypted_password|document_root_of_user

my $guser_textdb="count_admin.txt";

####################======================##########################
my $gcounter_db="/var/lib/wwwcount/db/Countdb";
my $gauth_db="/var/lib/wwwcount/db/Authdb";
my $gcouter_lock_file="/var/lib/wwwcount/db/Count.lck";
####################=====================###########################

my $g_edit_authdb=0;
my $g_mode=0640;
my $g_r_flag=O_RDONLY;
my $g_rw_flag=O_RDWR|O_CREAT;


my $g_document_root='';
my $g_title="administer your own data of WWW homepage access counter";
my $script_name=$query->script_name;
my $path_info=$query->path_info;
#------------globals ends-------------------



print $query->header;

my $LOCAL_STYLE=<<EOF;
A:link { font-weight:normal; color: #00099; text-decoration: none; }
A:visited {color: #000099;text-decoration: none; }
A:hover { color:#9F9900; text-decoration: underline; }
EOF
;
print $query->start_html(
        -title=>"$g_title",
        -style=>$LOCAL_STYLE,
        -bgcolor=>"#ffffff",
        -link=>"#ff0000",
        -vlink=>"#00c900",
        -alink=>"#ffff00",
        -text=>"#000000");


# call routine based on path_info
&doModify if $path_info eq "/modify";
&doAddModifyAuthdb if $path_info eq "/addmod_authdb";


if ($query->param)
{
    &doWork();
}
else
{
    &printLoginForm();
}

##-----
# printLoginForm() - print the login form
##-----
sub printLoginForm
{
    print "<center>\n";
    print<<EOF;
    <blockquote>
        <h2>Count database administration</h2>
    Please enter your <b>Userid</b> and <b>Password</b> set by your 
    administrator to modify your own data in 
    <a href="http://www.fccc.edu/users/muquit/Count.html">
    WWW Homepage Access Counter 2.6+</a> database.
    <br>
    Database Module: DB_File
    </blockquote>
EOF
;
    print "<table border=0 bgcolor=\"#c0c0c0\" cellpadding=5 cellspacing=0>\n";

    print $query->start_form;

    #------------- userid
    print "<tr>\n";
    print "<td align=\"right\">\n";
    print "Userid:\n";
    print "</td>\n";

    print "<td>\n";
    print $query->textfield(-name=>'userid',
            size=>20);
    print "</td>\n";
    print "</tr>\n";

    #------------- password
    print "<tr>\n";
    print "<td align=\"right\">\n";
    print "Password:\n";
    print "</td>\n";

    print "<td>\n";
    print $query->password_field(-name=>'password',
            -size=>20);
    print "</td>\n";
    print "</tr>\n";

    #------------- submit
    print "<tr>\n";
    print "<td colspan=2 align=\"center\">\n";
    print "<hr noshade size=1>\n";
    print $query->submit(-name=>'button',-value=>'Edit Hits');
    print "\&nbsp;\&nbsp\n";
    print $query->submit(-name=>'button',-value=>'Edit Authdb');
    print "</td>\n";
    print "</tr>\n";


    print $query->end_form;

    print "</table>\n";
    print "</center>\n";

}

##-------
# doWork() 
##-------
sub doWork
{
    my $em='';
    my $button=$query->param('button');
    my $userid;

    # import the paramets into a series of variables in 'q' namespace
    $query->import_names('q');
    #  check if the necessary fields are empty or not
    $em .= "<br>You must specify your Userid!<br>" if !$q::userid;
    $em .= "You must specify your Password!<br>" if !$q::password;

    $userid="$q::userid";

    if ($button eq 'Help')
    {
        &printLoginForm();
        &printHelp();
        exit;
    }

    if ($button eq 'Edit Authdb')
    {
        if (&validateUser() != 0) # user is verified
        {
            if ($g_edit_authdb == 1)
            {
                &printEditAuthdbForm($userid,$g_document_root);
                exit;
            }
            else
            {
                &printError("You are not allowed to edit Auth database!");
                exit;
            }
        }
        else
        {
            &printError("Could not validate Userid: $userid!");
            return;
        }
    }

    print "Button=$button<br>\n" if $g_debug;

    if ($em)
    {
        &printLoginForm;
        &hLine("#99cccc");
        &printError($em);
        return;
    }

    if (&validateUser() == 0)
    {
        &printLoginForm;
        &hLine("#99cccc");
        &printError("Could not validate Userid: $q::userid");
        return;
    }

    # open the counter database and see if the url with the user document root
    # is in the database
    &printModifyForm($q::userid);

}

##-----
# printEditAuthdbForm()
# form to edit auth database
#------
sub printEditAuthdbForm
{
    my $userid=shift;

    use vars qw(%h $k $v);

    my @u=();
    my $urls;
    my $len;
    my $subs='';
    my $a='';
    my $line='';
    

    print "userid=$userid<br>\n" if $g_debug;

    if (! $userid)
    {
        &printError("No userid specified!");
        return;
    }

    print "doc root=$g_document_root<br>\n" if $g_debug;

    doLock();
    my $x=tie %h, 'AnyDBM_File', "$gauth_db",$g_r_flag,$g_mode;
    if (!$x)
    {
        &printError("Could not open Auth database: $gauth_db for reading");
        return;
    }

    $len=length($g_document_root);

    while (($k,$v)=each %h)
    {
        # remove terminating NULL from key. 
        $k =~ s/\x00$//;
        $v =~ s/\x00$//;

        $subs=substr($k,0,$len);
        if ($g_document_root eq $subs)
        {
            $line="$k\t$v";
            push(@u,$line);    
        }

    }

    $urls=@u;
    if ($urls >= 1)
    {

        print "<center><b>Add/Modify Authdb</b></center><br>\n";
        print "<b>Userid:</b> $userid<br>\n";
        print "<b>Document root:</b> $g_document_root<br>\n";
        print "<br>\n";
        print<<EOF;
        <center>
        To add a new key to the auth database, just edit any exising key.
        To delete an URL, click on the toggle button and press Submit.
            
EOF
;
        print "<table border=0 bgcolor=\"#c0c0c0\" cellpadding=5 cellspacing=0>\n";

        print $query->start_form(-action=>"$script_name/addmod_authdb");
        print "<tr align=\"center\">\n";
        print "<td><b>Delete</b></td>\n";

        print "<td align=\"center\">\n";
        print "<b>URL</b>\n";
        print "</td>\n";

        print "<td align=\"center\">\n";
        print "<b>Comment</b>\n";
        print "</tr>\n";

        my $counter=0;
        foreach $a (@u)
        {
            $counter++;
            ($k,$v)=split(/\t/,$a);
            print "<tr>\n";

            print "<td>\n";
            print $query->checkbox('selecturl',0,$k,$counter),"\n";
            print "</td>\n";

            print "<td>\n";
            print $query->textfield(-name=>"url_$counter",
                    -value=>"$k",
                    -label=>'',
                    -size=>50);
            print "</td>\n";

            print $query->hidden("\@hidden\@$k","$v");
            print $query->hidden("DocumentRoot","$g_document_root");

            print "<td>\n";
            print $query->textfield(-name=>"comment_$counter",
                    -value=>"$v",
                    -size=>30);
            print "</td>\n";
            print "</tr>\n";
        }

        print "<td colspan=3 align=\"center\">\n";
        &hLine("#aaaaaa");
        print $query->submit(-label=>'Submit',
                -value=>'Submit');
        print "</td>\n";
        print "</tr>\n";
        print $query->end_form;
        print "</table>\n";
        print "</center>\n";
    }
    else
    {
        print "<center>\n";
        print "<h2>Add URLs to Authtdb</h2>\n";
        print "<b>Userid:</b> $userid<br>\n";
        print "<b>Document root:</b> $g_document_root<br>\n";
        print "<table border=0 bgcolor=\"#c0c0c0\" cellpadding=5 cellspacing=0>\n";

        print $query->start_form(-action=>"$script_name/addmod_authdb");
        print "<tr align=\"center\">\n";
        print "<td align=\"center\">\n";
        print "<b>URL</b>\n";
        print "</td>\n";

        print "<td align=\"center\">\n";
        print "<b>Comment</b>\n";
        print "</td>\n";
        print "</tr>\n";

        my $counter=1;

        print $query->hidden("\@hidden\@$k","$v");
        print $query->hidden("DocumentRoot","$g_document_root");

        print "<tr>\n";
        print "<td>\n";
        print $query->textfield(-name=>"url_$counter",
                -value=>"$g_document_root",
                -label=>'',
                -size=>50);
        print "</td>\n";

        print "<td>\n";
        print $query->textfield(-name=>"comment_$counter",
                -value=>"comment",
                -size=>30);
        print "</td>\n";
        print "</tr>\n";

        print "<tr>\n";
        print "<td colspan=2 align=\"center\">\n";
        &hLine("#aaaaaa");
        print $query->submit(-label=>'Submit',
                -value=>'Submit');
        print "</td>\n";
        print "</tr>\n";
        print $query->end_form;
        print "</table>\n";
        print "</center>\n";

    }

    untie %h;
}


##-----
# printModifyForm() - query counter database and print the form to
#                     modify
##-----
sub printModifyForm
{
    my $userid=shift;

    use vars qw(%h $k $v);
    my @a=();
    my $urls='';
    my $url='';
    my $hits='';
    my $line='';
    my $i;
    my $counter=0;
    my $len;
    my $subs='';

    if (!$userid)
    {
        return;
    }

    my $x=tie %h, 'AnyDBM_File', "$gcounter_db",O_RDONLY,0644;
    if (!$x)
    {
        &printError("Could not open Counter database: <b>$gcounter_db</b> for reading<br>$!");
        return;
    }

    $urls=@a;
    $len=length($g_document_root);

    while (($k,$v)=each %h)
    {
         # remove terminating NULL
        $k =~ s/\x00$//;
        $v =~ s/\x00$//;

        # remote the IP part out of value
        my @hits=split(/:/,$v);

        $subs=substr($k,0,$len);

        if ($g_document_root eq $subs)
        {
            # TODO: error checking
            $line="$k\t$hits[0]";
            push(@a,$line);
        }
    }


    $urls=@a;
    $counter=0;
    if ($urls >= 1)
    {
        print "<center>\n";
        print "<table border=0 bgcolor=\"#c0c0c0\" cellpadding=5 cellspacing=0>\n";

        print "Userid: <b>$userid</b><br>\n";
        print "Allowed to edit Document root: <b>$g_document_root</b><br>\n";
        print $query->start_form(-action=>"$script_name/modify");

        print "<tr align=\"center\">\n";
        print "<td align=\"center\">\n";
        print "URL\n";
        &hLine("#aaaaaa");
        print "</td>\n";

        print "<td align=\"center\">\n";
        print "Hits\n";
        &hLine("#aaaaaa");
        print "</tr>\n";
        foreach $i (sort @a)
        {
            $counter++;
            print "<tr>\n";
            print "<td align=\"right\">\n";
            ($url,$hits)=split(/\t/,$i);
            print "<b>$counter</b>. <a href=\"$url\">$url<\/a>\n";
            print "</td>\n";

            print $query->hidden("\@hidden\@$url","$hits");

            print "<td>\n";
            print $query->textfield(-name=>"hits_$counter",
                    -value=>"$hits",
                    -size=>12);
            print "</td>\n";
            print "</tr>\n";
        }

        #------------- submit
        print "<td colspan=2 align=\"center\">\n";
        &hLine("#aaaaaa");
        print $query->submit(-label=>'Submit',
                -value=>'Submit');
        print "</td>\n";
        print "</tr>\n";

        print $query->end_form;
        print "</table>\n";
        print "</center>\n";

    }
    else
    {
        &printError("<center>No match found in Count database with document root:<br><b>$g_document_root</b></center>");
    }


    print "urls=$urls<br>" if $g_debug;

    untie %h;
}

##------
# printError() - print error message
##------
sub printError
{
    my $em=shift;
    print<<EOF;
<center>
        <table border=0 bgcolor="#000000" cellpadding=0 cellspacing=0>
        <tr>
            <td>
                <table border=0 width="100%" cellpadding=5 cellspacing=1>
                    <tr">
                        <td bgcolor="#ffefd5" width="100%">
                        
                        <font color="#ff0000"><b>Error -</b></font>
                        $em</td>
                    </tr>
                </table>
            </td>
        </tr>
            
        </table>
</center>
<p>
EOF
;
}


##--
# validate login name
# returns 1, if validated successfully
#         0 if  validation fails due to password or non existence of login 
#           name in text database
##--
sub validateUser
{
    my $rc=0;
    my ($u,$p,$http,$url);
    my $userid=$query->param('userid');
    my $plain_pass=$query->param('password');

    # open the text database
    unless(open(PFD,$guser_textdb))
    {
        &printError("Could not open user text database: $guser_textdb");
        return;
    }

    # first check if user exist
    $g_document_root='';
    while (<PFD>)
    {
        chomp;
        ($u,$g_edit_authdb,$p,$g_document_root)=split(/\|/,$_);
        if ($userid eq $u)
        {
            print "<br>docroot=$g_document_root<p>\n" if $g_debug;
            $rc=1;
            last;
        }
    }
    close(PFD);

    if (crypt($plain_pass,$p) ne $p)
    {
        $rc=0;
    }

    return ($rc);
}



sub compareArrays
{
#
# by Jim, Feb-04-1998
#
    my($a1,$a2) = @_;
    # a1 is pointer to array
    # a2 is pointer to array

    my($i);

    unless(scalar(@$a1) == scalar(@$a2))
    {
        return 0;
    }

    for($i=0; $i < scalar(@$a1) ; ++$i)
    {
        unless($$a1[$i] eq $$a2[$i])
        {
            return 0;
        }
    }

    return 1;
}


#------
# doModify
#------
sub doModify
{
    my @hiddena=();
    my @a=();
    my @b=();
    my %hidden=();
    my %normal=();
    my %changed=();
    my $ov='';
    my $nv='';
    my $name;
    my $dirty_flag=0;
    my $line='';
    my $i;
    my $url='';
    my $hits='';
    my $counter=0;
    my $q='';
    my $u='';
    my $v='';
    my $first=1;
    my $updated='';


    my $url;

    my $userid=$query->param('userid');
    my @allparams=$query->param;

    # allparams had hidden and normal field values. hiddens are the
    # original. Fortunately, order is hidden then normal. So we'll separate
    # the hidden and normals in two arrays. The array which contains the
    # hidden values, the content is, url:value. But the normal array b
    # contains just the normal values. Then we'll go through all the
    # elements of array a and check if the value of the array with the
    # same index is same or not. If not same, the value is changed, update
    # the database. 
    # --muquit, Aug-14-1999
    foreach $name (@allparams)
    {
        $q=$query->param($name);
        $line="$name\t$q";
        if ($name =~ /\@hidden\@/)
        {
            push(@a,$line);
        }
        else
        {
            push(@b,$q);
        }
    }

    $counter=0;
    foreach $i (@a)
    {
        ($url,$hits)=split(/\t/,$i);
        if ($b[$counter] ne $hits)
        {
            $changed{$url}=$b[$counter];
            $dirty_flag=1;
        }
        $counter++;
    }
    if ($dirty_flag == 0)
    {

        &printError("Nothing to update!");
        exit;
    }
    else
    {
        # open the database for updaing.
        doLock();
#        my $x=tie %h, 'DB_File', "$gcounter_db",O_RDWR,0640,$DB_HASH;

        my $x=tie %h, 'AnyDBM_File', "$gcounter_db",$g_rw_flag,$g_mode;

        if (!$x)
        {
            &printError("Could not open Counter database: $gcounter_db for writing");
            exit;
        }


        foreach $url (sort keys %changed)
        {
            $u= $url;
            $u =~ s/\@hidden\@//;
            $v=$changed{$url};

            # NULL terminate the key and value
            $u="$u\x00";
            $v="$v\x00";

            # make sure value is a number
            my $tmp=$v;
            $tmp =~ s/\x00//;
            if ($tmp =~ /\D/)
            {
                $u =~ s/\x00//;
                $v =~ s/\x00//;
                &printError("Key: <b>$u</b> rejected<br> value <b>$v</b> is not a number");
                next;
            }


            $h{$u}=$v;
            if ($first)
            {
                $updated="<b>Database updated</b><br>";
                $first=0;
            }
            else
            {
                $updated='';
            }
    print<<EOF;
<center>
    $updated
        <table border=0 bgcolor="#c0c0c0" cellpadding=0 cellspacing=0 
        width="60%">
        <tr>
            <td>
                <table border=0 width="100%" cellpadding=10 cellspacing=2>
                    <tr align="center">
                        <td bgcolor="#000099" width="100%" align="right">
                        <font color="#00ffff">
$u
                        </font>
                        </td>
                        <td bgcolor="#000099" width="100%" align="right">
                        <font color="#00ffff">
$v
                        </font>
                        </td>


                    </tr>
                </table>
            </td>
        </tr>
            
        </table>
</center>
<p>
EOF
;

        }

        untie %h;
    }

    exit;
}


#-----------------
# horizontal line
#-----------------
sub hLine
{
    my $color=shift;

    print<<EOL;
    <br>
    <table border=0 cellspacing=0 cellpadding=0 width=100%>
        <tr>
            <td bgcolor="$color" colspan=4>
               <table border=0 cellspacing=0 cellpadding=0>
                    <tr>
                        <td height=3></td>
                    </tr>
               </table>

            </td>
        </tr>
    </table>
<p>
EOL
;
}

##---
# printHelp()
#----
sub printHelp
{
        &hLine("#000088");
    print<<EOF;
    <blockquote>
        <h2>Counter Hits administration Help</h2>
    </blockquote>
EOF
;
}
sub LOCK_SH { 1 }
sub LOCK_EX { 2 }
sub LOCK_NB { 4 }
sub LOCK_UN { 8 }

#---
# doLock()
#---
sub doLock
{
    unless (open(LOCK_FD,$gcouter_lock_file))
    {
        &printError("Unable to lock, opening file $gcouter_lock_file failed");
        return;
    }
    unless (flock(LOCK_FD,LOCK_SH|LOCK_NB))
    {
        unless (flock(LOCK_FD,LOCK_SH))
        {
            &printError("Unable to lock, flock() failed");
            return;
        }
    }
}

##-----
# doAddModifyAuthdb()
# add or modify auth database
#------
sub doAddModifyAuthdb
{
    my @hiddena=();
    my @a=();
    my @b=();
    my %hidden=();
    my %normal=();
    my %changed=();
    my $ov='';
    my $nv='';
    my $name;
    my $dirty_flag=0;
    my $line='';
    my $i;
    my $url_h='';
    my $comment_h='';
    my $url='';
    my $comment='';
    my $counter=0;
    my $q='';
    my $u='';
    my $v='';
    my $first=1;
    my $updated='';
    my $docroot='';
    my $len;
    my $subs='';
    my @cba=();

    my $url;
    my $userid=$query->param('userid');
    my @allparams=$query->param;

    my $key='';
    my $value='';

    $docroot=$query->param('DocumentRoot');
    if (! $docroot)
    {
        &printError("No document root found, aborting!");
        exit;
    }
    $len=length($docroot);
    print "docroot=$docroot<br>\n" if $g_debug;

    foreach $name (@allparams)
    {
        $key='';
        $value='';
        $q=$query->param($name);
        $line="$name\t$q";
        if ($name eq 'DocumentRoot')
        {
            next;
        }
        if ($name eq 'selecturl')
        {
            @cba=$query->param($name);
            next;
        }

        if ($name =~ /\@hidden\@/)
        {
            push(@a,$line);
        }
        else
        {
            if ($name =~ /url_[0-9]+/)
            {
                $key=$query->param($name);

                my $comm =$name;
                $comm =~ /url_([0-9]+)/;
                $comm="comment_$1";
                $value=$query->param($comm);
            }
            if ($key && $value)
            {
                $line="$key\t$value";
                push(@b,$line);
            }

        }
    }

    $counter=0;
    $dirty_flag=0;
    foreach $i (@a)
    {
        ($url_h,$comment_h)=split(/\t/,$i);
        $url_h =~ s/\@hidden\@//;

        ($url,$comment)=split(/\t/,$b[$counter]);
        if (($url_h ne $url) || ($comment_h ne $comment))
        {
            $changed{$url}=$comment;
            $dirty_flag=1;
        }
        $counter++;
    }

    if ($dirty_flag == 0)
    {
        if (scalar(@cba))
        {
            # open the auth database for writing
            doLock();
#            my $x=tie %h, 'DB_File', "$gauth_db",O_RDWR,0640,$DB_HASH;
            my $x=tie %h, 'AnyDBM_File', "$gauth_db",$g_rw_flag,$g_mode;
            if (!$x)
            {
                &printError("Could not open Counter database: $gauth_db for writing");
                exit;
            }
            foreach (@cba)
            {

                my $delurl="$_";

                #make sure the user can delete her own url only
                $subs=substr($delurl,0,$len);
                if ($docroot ne $subs)
                {
                    &printError("<b><font color=\"#ff000\">Error:</font></b> Will not delete URL <i>$u</i>. It violates the document root: <i>$docroot</i> set by the admin. Note, you only can delete your own URL.\n");
            print "<br>\n";
                }
                else
                {
                    # NULL terminate the key
                    $delurl="$delurl\x00";
                    delete $h{$delurl};
                    if ($first)
                    {
                        $updated="<b>Auth database updated, deleted URL</b><br>";
                        $first=0;
                    }
                    else
                    {
                        $updated='';
                    }

print<<EOF;
<center>
$updated
    <table border=0 bgcolor="#c0c0c0" cellpadding=0 cellspacing=0 
    width="60%">
    <tr>
        <td>
            <table border=0 width="100%" cellpadding=10 cellspacing=2>
                <tr align="center">
                    <td bgcolor="#000099" width="100%" align="right" nowrap>
                    <font color="#00ffff">
$delurl
                    </font>
                    </td>
                    <td bgcolor="#000099" width="100%" align="right" nowrap>
                    <font color="#00ffff">
-not shown-
                    </font>
                    </td>


                </tr>
            </table>
        </td>
    </tr>
        
    </table>
</center>
EOF
;
                }
            }

            if ($x)
            {
                untie %h;
            }
        }
        else
        {
            &printError("Nothing to update!");
        }

        exit;
    }
    else
    {
        $first=1;
        # open the auth database for writing
        doLock();
#        my $x=tie %h, 'DB_File', "$gauth_db",O_RDWR,0640,$DB_HASH;
        my $x=tie %h, 'AnyDBM_File', "$gauth_db",$g_rw_flag,$g_mode;
        if (!$x)
        {
            &printError("Could not open auth database: $gauth_db for writing");
            exit;
        }

        foreach $url (sort keys %changed)
        {
            $u= $url;
            $u =~ s/\@hidden\@//;
            $v=$changed{$url};


            # It is critical that the
            # user can only updated her own URL. so the the user's docroot must
            # be present in the supplied URL.
            # cut out the document root from the url, it must be equal
            # to the document root set by the admin the count_admin.txt
            # file
            # --muquit Aug-18-199
            $subs=substr($u,0,$len);
            if ($docroot ne $subs)
            {
                &printError("<b><font color=\"#ff000\">Error:</font></b> Ignoring URL <i>$u</i>. It violates the document root: <i>$docroot</i> set by the admin. Note, you only can update your own URL.\n");
                print "<br>\n";
                next;
            }

            # NULL terminate the key and value
            $u="$u\x00";
            $v="$v\x00";
            $h{$u}=$v;
            
            if ($first)
            {
                $updated="<b>Auth database updated</b><br>";
                $first=0;
            }
            else
            {
                $updated='';
            }
    print<<EOF;
<center>
    $updated
        <table border=0 bgcolor="#c0c0c0" cellpadding=0 cellspacing=0 
        width="60%">
        <tr>
            <td>
                <table border=0 width="100%" cellpadding=10 cellspacing=2>
                    <tr align="center">
                        <td bgcolor="#000099" width="100%" align="right" nowrap>
                        <font color="#00ffff">
$u
                        </font>
                        </td>
                        <td bgcolor="#000099" width="100%" align="right" nowrap>
                        <font color="#00ffff">
$v
                        </font>
                        </td>


                    </tr>
                </table>
            </td>
        </tr>
            
        </table>
</center>
<p>
EOF
;

        }
        if ($x)
        {
            untie %h;
        }
    }
    exit;
}
